<?php
/*
* Get My Current IP info mbot PHP Script v. 1.4 (main code)
* 2011.11.09
* 
*  2011 Skurat Denis (a.k.a. Dionys)
* @contact: skiner@inbox.ru
* 
* Based on www.ip-adress.com
*/

/* CONFIGURATION */
define('SCRIPT_NAME',		'MyIP Info');			// Script name.
define('SCRIPT_VERSION',	'1.0.0.4');				// Script version
define('SCRIPT_CFG',		'MSP_MyIP');			// Script config section.
define('SYM_ENTER',			chr(0x0D).chr(0x0A));	// Enter
define('WORK_PATH',			realpath('./') .'/mbot/scripts/autoload/MyIP');
/* END CONFIGURATION */

function mbot_load()
{ 
	if (MBOT_VERSION >= 0x01000000)
	{
		$icon_miranda	= mb_IconLoadSkin(SKINICON_OTHER_MIRANDA);
		$icon_mbot		= 0;
		$icon_check		= mb_IconLoadSkin(218);
		$icon_uncheck	= mb_IconLoadSkin(219);

		mb_SelfRegister(MB_EVENT_MENU_COMMAND, 1); 
		mb_SelfSetInfo(SCRIPT_NAME .' v.'. SCRIPT_VERSION .' by Dionys');
		mb_Echo(SCRIPT_NAME .' v.'. SCRIPT_VERSION .' .'. SYM_ENTER);
		mb_MenuAdd(SCRIPT_NAME, 0, 'MyIP', $icon_mbot, 0x00);

		$menu_name	= mb_SysTranslate('Show MyIP PopUp');
		$popup_var	= @mb_CSettingGet(NULL, SCRIPT_CFG, 'myip_popup_var');
		if($popup_var === FALSE)
		{
			mb_CSettingAdd(NULL, SCRIPT_CFG, DBVT_BYTE, 'myip_popup_var', 0x01);
			$myip_settings = mb_MenuAdd($menu_name, 0, 'MyIP_Set', $icon_check, null, null, null, null, null, 0);
		}
		else if ($popup_var == 0x01)
		{
			$myip_settings = mb_MenuAdd($menu_name, 0, 'MyIP_Set', $icon_check, null, null, null, null, null, 0);
		}
		else if ($popup_var == 0x02)
		{
			$myip_settings = mb_MenuAdd($menu_name, 0, 'MyIP_Set', $icon_uncheck, null, null, null, null, null, 0);
		}
		else
		{
			mb_CSettingAdd(NULL, SCRIPT_CFG, DBVT_BYTE, 'myip_popup_var', 0x01);
			$myip_settings = mb_MenuAdd($menu_name, 0, 'MyIP_Set', $icon_check, null, null, null, null, null, 0);
		}
		
		mt_setvar('myip_popup_set', $myip_settings, 1, 0);
	}
	else
	{
		mb_echo(SCRIPT_NAME .': This scripts requires mBot 1.0.0.0 or later!');
	}
}

function MyIP($param, $cid, $hmenu)
{
	$hPage = parse_data(get_data());

	if (!empty($hPage['IP']))
	{
		com_run('@echo off && echo '. $hPage['IP'] .'|.\mbot\scripts\autoload\MyIP\clip.exe && exit /b', false);

		$output	=	'IP: '. $hPage['IP'] . SYM_ENTER.
					'Location: '.$hPage['LOC'] . SYM_ENTER .
					'Provider: '.$hPage['ISP'] . SYM_ENTER .
					SYM_ENTER . 'Attention: IP has been copied to the clipboard.' . SYM_ENTER.
					SYM_ENTER . 'www.ip-adress.com';
	}
	else
	{
		$output	=	'ERROR Information request!'. SYM_ENTER;
	}

	if (@mb_CSettingGet(NULL, SCRIPT_CFG, 'myip_popup_var') == 0x01)
	{
		mb_PUAdd(NULL, 'Your IP Info', $output, 0, 0, mb_IconLoadSys(IDI_INFORMATION));
	}
	else if(@mb_CSettingGet(NULL, SCRIPT_CFG, 'myip_popup_var') == 0x02)
	{
		mb_MsgBox($output, 'Your IP Info', 0);
	}
	else
	{
		mb_MsgBox('DB error! Reboot MirandaIM.', 'Your IP Info', 0);
	}
}

function MyIP_Set()
{
	if(@mb_CSettingGet(NULL, SCRIPT_CFG, 'myip_popup_var') == 0x01)
	{
		mb_MenuModify(mt_getvar('myip_popup_set'), mb_SysTranslate('MyIP PopUp off'), mb_IconLoadSkin(219), null, 'MyIP_Set');
		mb_CSettingAdd(NULL, SCRIPT_CFG, DBVT_BYTE, 'myip_popup_var', 0x02);
	}
	else if(@mb_CSettingGet(NULL, SCRIPT_CFG, 'myip_popup_var') == 0x02)
	{
		mb_MenuModify(mt_getvar('myip_popup_set'), mb_SysTranslate('MyIP PopUp on'), mb_IconLoadSkin(218), null, 'MyIP_Set');		
		mb_CSettingAdd(NULL, SCRIPT_CFG, DBVT_BYTE, 'myip_popup_var', 0x01);
	}
	else
	{
		mb_MsgBox('DB error! Reboot MirandaIM.', 'Your IP Info', 0);
	}
}

/* get data */
function get_data()
{
	$host		= 'www.ip-adress.com';
	$port		= 80;
	$timeout	= 5;
	$path		= '';
	$page		= '';
	$headers	=	'GET /' .$path .' HTTP/1.0'. SYM_ENTER .
					'Referer: http://'. $host .'/ '. SYM_ENTER .
					'User-Agent: Mozilla/5.0 (Windows NT 5.1; rv:7.0a2) Gecko/20110720 Firefox/7.0a2'. SYM_ENTER .
					'Host: '. $host . SYM_ENTER .
					'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8'. SYM_ENTER .
					'Accept-Language: ru-ru,ru;q=0.8,en-us;q=0.5,en;q=0.3'. SYM_ENTER .
					'Accept-Charset: windows-1251, utf-8, utf-16, iso-8859-1;q=0.6, *;q=0.1'. SYM_ENTER .
					'Connection: keep-alive'. SYM_ENTER .
					'DNT: 1'. SYM_ENTER .SYM_ENTER;

	$fp = @fsockopen ('tcp://'.$host, $port, $errno, $errstr, $timeout);
	@stream_set_timeout($fp, $timeout);

	if ($fp)
	{
		// get page
		fputs ($fp, $headers);
		while (!feof ($fp))
		{ 
			$fdata = @fgets($fp, 1024);
			if($fdata == '') break;
			$page .= $fdata;
		}

		// close socket
		fclose($fp);
	}

	return $page;
}

/* parse data */
function parse_data($parse_page)
{
	$parse_page = substr($parse_page, strpos($parse_page, 'Your IP address is: ') + 20);
	$page['IP'] = substr($parse_page, 0, strpos($parse_page, '</h3>'));
	$parse_page = substr($parse_page, strpos($parse_page, 'Your IP Address Location: ') + 26);
	$page['LOC'] = substr($parse_page, 0, strpos($parse_page, ' in '));
	$parse_page = substr($parse_page, strpos($parse_page, 'ISP of your IP: ') + 16);
	$page['ISP'] = substr($parse_page, 0, strpos($parse_page, '</h3>'));
	
	return $page;
}

/* Run command with hide dos console */
function com_run($cmd, $echo = false)
{
	$cmdline = 'cmd /C '. $cmd;
	
	if ($echo)
	{
		$echofile = @tempnam('createtosystemtempfolder', 'COM');
		$cmdline .= ' > $echofile';
		$mode = true;	// wait app
    }
	else
	{
		$mode = false;	// not wait app
	}

	$WsShell = new COM('WScript.Shell');
	$oExec = $WsShell->Run($cmdline, 0, $mode);

	if ($echofile)
	{
        $echostr = file_get_contents($echofile);
		@unlink($echofile);
	}
	else
	{
		$echostr = null;
	}

	//return $oExec == 0 ? true : false;
	return $echostr;
}
?>